	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Convert/Convert to 3D Polys no Base.py;
	# Created by Bill Wood 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
		#Name
		this = Marionette.Node( "Convert to 3D Polys NB" )
		this.SetDescription( "Converts an object to a group of 3D polygon(s). This node successfully converts rectangles, circles, arcs, polylines, polygons, ovals, lines, straight walls, curved walls, extrusions, and roofs" )
	
		#Input Ports
		obj = Marionette.PortIn( vs.Handle(0),"hObj" )
		obj.SetDescription( "an object to be converted" )
	
		ignorebase = Marionette.PortIn(False, 'bIgnoreBase')
		ignorebase.SetDescription( "Ignore flat bottom 3D polygons" )
	
		#Output Ports
		polys = Marionette.PortOut('hPolys 3D')
		polys.SetDescription( "the 3D polygon(s) after the conversion which can be passed to Extrude Path Input" )
	
		this.SetLinksObjects()
	
	def RunNode(self):
	
		def build3Dpolys(objH,ignorebase):
			btest,refID = vs.IsPlanarObj(objH)
			if btest:
				ignorebase = False 
	
			if ignorebase:
				objty = vs.GetTypeN(objH)
				if (objty == 84): # Solid
					btest,pt3D,xRot,yRot,zRot = vs.GetEntityMatrix(objH)
					x1 = pt3D[0]
					y1 = pt3D[1]
					z1 = pt3D[2]
					btest,pt3D,xRot,yRot,zRot = vs.GetEntityMatrix(vs.FIn3D(objH))
					vs.Move3DObj(objH,-x1,-y1,-z1)
					vs.SetRot3D(objH,-xRot,-yRot,-zRot,0,0,0)
				else:
					btest,pt3D,xRot,yRot,zRot = vs.GetEntityMatrix(objH)
					x1 = pt3D[0]
					y1 = pt3D[1]
					z1 = pt3D[2]
					vs.Move3DObj(objH,-x1,-y1,-z1)
					vs.SetRot3D(objH,0,0,0,0,0,0)
	
				pt2D,z = vs.Get3DCntr(objH)
				hgt,wid,dep = vs.Get3DInfo(objH)
				basehgt = z-dep/2
	
			grpH = vs.ConvertTo3DPolys(objH)
			
			polys = []
	
			objH = vs.FInGroup(grpH)
			while objH != vs.Handle(0):
				tempH  = vs.NextObj(objH)
				if ignorebase:
					pt2D,z = vs.Get3DCntr(objH)
					if vs.Eq(z,basehgt,.0001):
						vs.DelObject(objH)
					else:
						polys.append(objH)
				else:
					polys.append(objH)
				objH = tempH
	
	
			if ignorebase:
				vs.Set3DRot(grpH,xRot,yRot,zRot,0,0,0)
				vs.Move3DObj(grpH,x1,y1,z1)
	
			return grpH,polys
	
		obj = self.Params.obj.value
		ignorebase = self.Params.ignorebase.value
		
		grpPoly,polys = build3Dpolys(obj,ignorebase)
		self.Params.polys.value = polys
	
		vs.HUngroup(grpPoly)