	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Convert/Get 3D Edge.py;
	# Created by Bill Wood 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
		this = Marionette.Node( "Get 3D Edge" )
		this.SetDescription( "Returns an edge of a 3D polygon, given its start point index. If the start point is the last vertex of the polygon, the edge's end point would be the first vertex of the polygon" )
		poly = Marionette.PortIn( vs.Handle(0), 'hPoly' )
		poly.SetDescription( "a 3D polygon" )
		startIdx = Marionette.PortIn( 0 )
		startIdx.SetDescription( "the index of the edge's start point" )
		
		start = Marionette.PortOut()
		start.SetDescription( "the start point of the edge" )
		end = Marionette.PortOut()
		end.SetDescription( "the end point of the edge" )
	
	def RunNode(self):
		poly = self.Params.poly.value
		at = self.Params.startIdx.value
	
		a = vs.GetPolyPt3D(poly, at)
		
		vertNum = vs.GetVertNum(poly)
		if at == vertNum - 1:
			if vs.IsPolyClosed(poly):
				b = vs.GetPolyPt3D(poly, 0)
			else:
				b = vs.GetPolyPt3D(poly, at)
		else:
			b = vs.GetPolyPt3D(poly, at + 1)
	
		self.Params.start.value = a
		self.Params.end.value = b