	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Convert/Get poly invisible.py;
	# Created by Bill Wood 16/2/21
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "Get Poly Invisible" )
		this.SetDescription( "Convert grouped or single polygon(s),polyline(s),arc(s) with invisible segments to seperate visible polygon." )
	
		#Input Ports
		obj = Marionette.PortIn( vs.Handle(0), '2D poly(s)' )
		obj.SetDescription( "an 2D poly object(s) to be converted" )
	
		#OIP Controls
	
		#Output Ports
		polys = Marionette.PortOut('2D poly(s)')
		polys.SetDescription( "the 2D polygon(s) after the conversion which can be passed to Extrude Path Input" )
	
	#BEHAVIOR
		this.SetLinksObjects()
	
	def RunNode(self):
	
		def getpolyinvis(srcpolyH,objty):
			if (objty == 6): # arc
				polyH = vs.CreateDuplicateObject(srcpolyH,None)
				polyH = vs.ConvertToPolyline(polyH);
				vs.DelVertex(polyH,2)
	
			elif (objty in [5,21]): # single 2D polygon or polyline
				polyH = vs.CreateDuplicateObject(srcpolyH,None)
				cnt = vs.GetVertNum(polyH)
				for i in range(cnt): # start i = 0
					vis = vs.GetVertexVisibility(polyH,i)
					vs.SetVertexVisibility(polyH,i,not vis)
			
			return polyH
	
		#inputs
		objH  = self.Params.obj.value
		plist = []
	
		objty = vs.GetTypeN(objH)
		if (objty == 11): # group of 2D polys
			grpobjH = vs.FInGroup(objH)
			while grpobjH != None:
				objty = vs.GetTypeN(grpobjH)
				polyinvis = getpolyinvis(grpobjH,objty)
				plist.append(polyinvis)
				grpobjH = vs.NextObj(grpobjH)
	
		else: # single 3D poly
			polyinvis = getpolyinvis(objH,objty)
			plist = [polyinvis]
	
		#outputs
		self.Params.polys.value = plist