	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Convert/Poligonize poly UI.py;
	# Created by Bill Wood 16/2/21
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "Poligonize Path UI" )
		this.SetDescription( "Poligonize 2D polygon/polyline with a specified segment length." )
	
		#Input Ports
		obj = Marionette.PortIn( vs.Handle(0), '2D poly(s)' )
		obj.SetDescription( "an 2D poly object(s) to be converted" )
	
		seglength = Marionette.OIPControl('Spacing', Marionette.WidgetType.RealCoord, 1000)
		seglength.SetDescription( "Maximum segment length spacing" )
		
		setoutOptions = ['From Start','From End','Centred','Equal']
		setout = Marionette.OIPControl('Setout', Marionette.WidgetType.Popup, 0, setoutOptions)
		setout.SetDescription( "Setout method used for plaving extrudes" )
	
		startoffset = Marionette.OIPControl('Start Offset', Marionette.WidgetType.RealCoord, 0)
		startoffset.SetDescription( "Path offset at start" )
	
		endoffset = Marionette.OIPControl('End Offset', Marionette.WidgetType.RealCoord, 0)
		endoffset.SetDescription( "Path offset at end" )
	
		straight = Marionette.OIPControl('Ignore straight segments', Marionette.WidgetType.Bool, False)
		straight.SetDescription( "Ignore straight segments for poligonization" )
	
		seperate = Marionette.OIPControl('Split into seperate segments', Marionette.WidgetType.Bool, True)
		seperate.SetDescription( "Split path into seperate segments at vertex ends" )
	
		#OIP Controls
	
		#Output Ports
		polys = Marionette.PortOut('2D poly(s)')
		polys.SetDescription( "the 2D polygon(s) after the conversion which can be passed to Extrude Path Input" )
	
	#BEHAVIOR
		this.SetLinksObjects()
	
	def RunNode(self):
	
		def poligonize(srcpolyH,seglen,straight):
			objty = vs.GetTypeN(srcpolyH)
			polyH = []
			if (objty in [3,4,6,13,5,21]): # Rectangle,Oval,Arc,Round Rectangle,Polygon,Polyline
				if (objty not in [5,21]):
					srcpolyH = vs.ConvertToPolyline(srcpolyH); # converts source object
					
				polyH = vs.Polygonize(srcpolyH,seglen,straight) # creates copy
				vs.DelObject(srcpolyH)
	
			return polyH
	
		#inputs
		objH  = self.Params.obj.value
		seglength = self.Params.seglength.value
		straight = self.Params.straight.value
	
		plist = []
	
		if (seglength > 0):
			objty = vs.GetTypeN(objH)
			if (objty == 11): # group of 2D polys
				grpobjH = vs.FInGroup(objH)
				while grpobjH != None:
					polyinvis = poligonize(grpobjH,seglength,straight)
					plist.append(polyinvis)
					grpobjH = vs.NextObj(grpobjH)
	
			else: # single 3D poly
				polyH = poligonize(objH,seglength,straight)
				plist = [polyH]
	
		#outputs
		self.Params.polys.value = plist