	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Input/Linear/EP Line Location.py;
	# Created by Bill Wood 29/7/18
	# Edited Converted to VW 2020 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Location Line" )
		this.SetDescription( 'Set location position of Extrude Shape' )
	
		#Input Ports
		inputPosstart = Marionette.PortIn([], 'posStart' )
		inputPosstart.SetDescription( "The input 2D or 3D start position" )
	
		inputPosend = Marionette.PortIn([], 'posEnd' )
		inputPosend.SetDescription( "The input 2D or 3D end position" )
	
		inputRotations = Marionette.PortIn(0, 'rotXYZ' )
		inputRotations.SetDescription( 'The input for XYZ rotations' )
	
		#Output Ports
		extrH = Marionette.PortOut('Path')
		extrH.SetDescription( "The result EP Extrude location definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		inputFrom = self.Params.inputPosstart.value # error check valid positions
		inputTo   = self.Params.inputPosend.value # error check valid positions
		WProtations   = self.Params.inputRotations.value
	
		#outputs
		self.Params.extrH.value = {'EL':[(inputFrom,inputTo),(rotX, rotY, rotZ)]}