	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Input/Path/Get Poly Holes.py;
	# Created by Bill Wood 23/5/20
	
	class Params(metaclass = Marionette.OrderedClass):
		def getinputObject(inputObject):
			if (type(inputObject) == vs.Handle): # single object
				objlistH = [inputObject]
			else:
				objlistH = inputObject # list of objects??
			
			newobjlistH = []
			if isinstance(objlistH,list):
				for objH in objlistH:
					objtype = vs.GetTypeN(objH)			
					if objtype in [5,21]: # 2D polygon/polyline objects
						newobjlistH.append(objH)
				if len(newobjlistH) == 0:
					return 0 # invalid objects in objectlist
				else:
					return newobjlistH
			else:
				return 0 # not a list
	
	#APPEARANCE
		#Name
		this = Marionette.Node( "Get Poly Holes" )
		this.SetListAbsorb()			  # mark this node as list absorbing
		this.SetDescription( 'Extract polygon/polyline holes as list of objects' )
	
		#Input Ports
		pathpioH = Marionette.PortIn(vs.Handle(0), 'hPath(s)')
		pathpioH.SetDescription( "Path object used for extrusion" )
	
	
		#Output Ports
		holes = Marionette.PortOut('hHole(s)')
		holes.SetDescription( "The resultant hole polygon/polylines" )
	
	#BEHAVIOR
	
	def RunNode(self):
	
		#inputs
		pathpioH = self.Params.getinputObject(self.Params.pathpioH.value)
		holes = []
		for pathH in pathpioH:
			holeset,numholes = vs.GetNumHoles(pathH)
			if holeset:
				for i in range(numholes):
					holeset,holeH = vs.GetHole(pathH, i+1)
					if holeset:
						holes.append(holeH)
		
		#outputs
		self.Params.holes.value = holes