	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Input/Point/EP Extrude Point Input UI.py;
	# Created by Bill Wood 29/7/18
	# Edited Converted to VW 2020 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Extrude Point Input UI" )
		this.SetDescription( 'Extrude Shape options definition.' )
	
		#Input Ports
		location = Marionette.PortIn(vs.Handle(0), 'Location(s)')
		location.SetDescription( "Location 2D/3D or locus 2D/3D used for extrusion or unset for passing to EP Place Shape" )
	
		#OIP Input Controls
		topoffset = Marionette.OIPControl('Top Offset', Marionette.WidgetType.RealCoord, 0)
		topoffset.SetDescription( "Extrude top offset" )
	
		extrheight = Marionette.OIPControl('Height', Marionette.WidgetType.RealCoord, 1)
		extrheight.SetDescription( "Extrude height" )
		
		bottomZ = Marionette.OIPControl('Bottom Z', Marionette.WidgetType.RealCoord, 0)
		bottomZ.SetDescription( "Extrude bottom base height offset" )
	
		skewX = Marionette.OIPControl('Skew X', Marionette.WidgetType.RealCoord, 0)
		skewX.SetDescription( "Skew extrude by offset in X" )
		
		skewY = Marionette.OIPControl('Skew Y', Marionette.WidgetType.RealCoord, 0)
		skewY.SetDescription( "Skew extrude by offset in Y" )
	
		keepvertical = Marionette.OIPControl('Keep Offsets Vertical (Skew only)', Marionette.WidgetType.Bool, False)
		keepvertical.SetDescription( "Keep Extrude offsets vertical (Skew only)" )
	
		maintainshape = Marionette.OIPControl('Maintain Shape (Skew only)', Marionette.WidgetType.Bool, False)
		maintainshape.SetDescription( "Maintian Extrude shape in skew (Skew only)" )
	
		#Output Ports
		shape = Marionette.PortOut('Options')
		shape.SetDescription( "The resultant path options definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		location	 = self.Params.location.value
		topoffset	 = self.Params.topoffset.value
		extrheight   = self.Params.extrheight.value
		bottomZ		 = self.Params.bottomZ.value
		skewX		 = self.Params.skewX.value
		skewY		 = self.Params.skewY.value
		keepvertical  = self.Params.keepvertical.value
		maintainshape = self.Params.maintainshape.value
		
		optionstring = {'EI':[location,{'topoffset':str(topoffset),'extrudehgt':str(extrheight),'baseZ':str(bottomZ),'skewX':str(skewX),'skewY':str(skewY),'verticaloffsets':str(bool(keepvertical)),'maintainshape':str(bool(maintainshape))}]}
	
		#outputs
		self.Params.shape.value = optionstring
	
	