	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Input/Point/EP Extrude Point Input.py;
	# Created by Bill Wood 29/7/18
	# Edited Converted to VW 2020 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
		def getinputObject(inputObject):
			if isinstance(inputObject,list):
				if not(inputObject.has_key('EO') or inputObject.has_key('EP')):
					inputObject = 0
			return inputObject
	
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Extrude Point Input" )
		this.SetDescription( 'The EP Extrude Shape input definition.' )
	
		#Input Ports
		location = Marionette.PortIn(vs.Handle(0), 'Location(s)')
		location.SetDescription( "Location position or loci 2D/3D object(s) used for extrusion" )
		
		topoffset = Marionette.PortIn(0, 'nTopOffset')
		topoffset.SetDescription( "Extrude top offset" )
	
		extrheight = Marionette.PortIn(1, 'nHeight')
		extrheight.SetDescription( "Extrude height" )
		
		bottomZ = Marionette.PortIn(0, 'nBottomZ')
		bottomZ.SetDescription( "Extrude bottom base height offset" )
	
		skewX = Marionette.PortIn(0, 'nSkewX')
		skewX.SetDescription( "Skew extrude by offset in X" )
		
		skewY = Marionette.PortIn(0, 'nSkewY')
		skewY.SetDescription( "Skew extrude by offset in Y" )
	
		keepvertical = Marionette.PortIn(False, 'bKeep Offsets Vertical (SK)')
		keepvertical.SetDescription( "Keep Extrude offsets vertical (Skew Only)" )
	
		maintainshape = Marionette.PortIn(False, 'bMaintain Shape (SK)')
		maintainshape.SetDescription( "Maintian Extrude shape in skew (Skew Only)" )
	
		#Output Ports
		shape = Marionette.PortOut('Options')
		shape.SetDescription( "The resultant path options definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		def getnumbval(value,defvalue):
			if isinstance(value,(list,tuple)):
				value = value[0]
			if isinstance(value,(int,float)):
				return value
			else:
				return defvalue
	
		def getboolval(bvalue):
			if isinstance(bvalue,list):
				return bvalue[0]
			else:
				return bvalue
	
		#inputs
		location	 = self.Params.getinputObject(self.Params.location.value) # pass through
		if location:
			topoffset	  = getnumbval(self.Params.topoffset.value,0)
			extrheight	  = getnumbval(self.Params.extrheight.value,0) # PIO sets minimum value
			bottomZ		  = getnumbval(self.Params.bottomZ.value,0)
			skewX		  = getnumbval(self.Params.skewX.value,0)
			skewY		  = getnumbval(self.Params.skewY.value,0)
			keepvertical  = getboolval(self.Params.keepvertical.value)
			maintainshape = getboolval(self.Params.maintainshape.value)
			
			optionstring = {'EI':[location,{'topoffset':str(topoffset),'extrudehgt':str(extrheight),'baseZ':str(bottomZ),'skewX':str(skewX),'skewY':str(skewY),'verticaloffsets':str(bool(keepvertical)),'maintainshape':str(bool(maintainshape))}]}
		else:
			optionstring = 0 # fail
	
		#outputs
		self.Params.shape.value = optionstring
	