	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Input/Point/EP Location Object.py;
	# Created by Bill Wood 29/7/18
	# Edited Converted to VW 2020 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
		def getinputObject(inputObject):
			if (type(inputObject) == vs.Handle): # single object
				objlistH = [inputObject]
			else:
				objlistH = inputObject # list of objects??
			
			newobjlistH = []
			if isinstance(objlistH,list):
				for objH in objlistH:
					objtype = vs.GetTypeN(objH)			
					if objtype in [9,17]: # 2D/3D loci objects
						newobjlistH.append(objH)
				if len(newobjlistH) == 0:
					return 0 # invalid objects in objectlist
				else:
					return newobjlistH
			else:
				return 0 # not a list
	
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Location Object" )
		this.SetListAbsorb()			 #  mark this node as list absorbing
		this.SetDescription( 'Set location of Extrude Shape based on supplied object' )
	
		#Input Ports
		inputObject = Marionette.PortIn(vs.Handle(0), 'hloci' )
		inputObject.SetDescription( "The input object which must be a 2D or 3D locus" )
	
		#Output Ports
		extrH = Marionette.PortOut('loc(s)')
		extrH.SetDescription( "The result EP Extrude location definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		inputObject = self.Params.getinputObject(self.Params.inputObject.value)
	
		#outputs
		if inputObject:
			self.Params.extrH.value = {'EO':inputObject}
		else:
			self.Params.extrH.value = 0