	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Input/Point/EP Location Position.py;
	# Created by Bill Wood 29/7/18
	# Edited Converted to VW 2020 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Location Position" )
		this.SetListAbsorb()			   # mark this node as list absorbing
		this.SetDescription( 'Set location position of Extrude Shape' )
	
		#Input Ports
		inputPosition = Marionette.PortIn([], 'pos3D(s)' )
		inputPosition.SetDescription( 'The input 2D or 3D position' )
	
		inputRotations = Marionette.PortIn((0,0,0), 'rotXYZ' )
		inputRotations.SetDescription( 'The input for XYZ rotations' )
	
		#Output Ports
		extrH = Marionette.PortOut('loc(s)')
		extrH.SetDescription( "The result EP Extrude location definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs  Note no error checking
		inputPosition = self.Params.inputPosition.value
		WProtations   = self.Params.inputRotations.value[0] # because of listabsorb
	
		#outputs
		self.Params.extrH.value = {'EP':[inputPosition,WProtations]}