	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Input/Point/Rotation 3D.py;
	# Created by Bill Wood 29/7/18
	# Edited Converted to VW 2020 22/5/20
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node('Rotation 3D')
		this.SetDescription('Creates a 3D reshape handle when used in a Marionette Object. Initial values are defined in the Object Info Palette.')
	
		#OIP Input Controls
		x = Marionette.OIPControl( 'X', Marionette.WidgetType.RealAngle, 0)
		x.SetDescription('A value representing the rotation about X axis')
		y = Marionette.OIPControl( 'Y', Marionette.WidgetType.RealAngle, 0)
		y.SetDescription('A value representing the rotation about Y axis')
		z = Marionette.OIPControl( 'Z', Marionette.WidgetType.RealAngle, 0)
		z.SetDescription('A value representing the rotation about Z axis')
	
		#Output Ports
		pt = Marionette.PortOut('rotXYZ')
		pt.SetDescription('A Control 3D point')
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		x = self.Params.x.value
		y = self.Params.y.value
		z = self.Params.z.value
		#script
	
		#outputs
		self.Params.pt.value = (x, y, z)
		