	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Input/Point/Working Plane.py;
	# Created by Bill Wood 29/7/18
	# Edited Converted to VW 2020 22/5/20
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node('RefID')	
		this.SetDescription('Working Plane reference ID') 
	
		#OIP Input Controls
		Int = Marionette.OIPControl( 'Working Plane', Marionette.WidgetType.Int, 0)
		Int.SetDescription('Get Working Plane rotations') 
		
		#Output Ports
		rotXYZ = Marionette.PortOut('rotXYZ')
		rotXYZ.SetDescription('X/Y/Z working plane rotation as a list')
		
	#BEHAVIOR
		
	def RunNode(self):
		#inputs
		WPRefID = self.Params.Int.value
		
		#script
		if isinstance(WPRefID,int):
			x, y, z, rotX, rotY, rotZ = vs.GetWorkingPlane(WPRefID)
			rot = (rotX, rotY, rotZ)
		else:
			rot = (0,0,0)
	
		#outputs
		self.Params.rotXYZ.value = rot