	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Mitres/EP Mitre Type.py;
	# Created by Bill Wood 29/8/18
	# Edited Converted to VW 2020 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Mitres" )
		this.SetDescription( 'Set start and end mitres for a Linear path (only)' )
	
		#OIP Input Controls
		# Mitre type worked out from values of angle
		
		starttopangle = Marionette.PortIn(0, 'nStartTopAngle')
		starttopangle.SetDescription( "Start mitre top angle either +ive ot -ive" )
		
		startsideangle = Marionette.PortIn(0, 'nStartSideAngle')
		startsideangle.SetDescription( "Start mitre side angle either +ive ot -ive" )
	
		starttopcentred = Marionette.PortIn(False, 'bStartTopCentred')
		starttopcentred.SetDescription( "Start mitre top angle centred on shape" )
	
		startsidecentred = Marionette.PortIn(False, 'bStartSideCentred')
		startsidecentred.SetDescription( "Start mitre side angle centred on shape" )
	
		endtopangle = Marionette.PortIn(0, 'nEndTopAngle')
		endtopangle.SetDescription( "End mitre top angle either +ive ot -ive" )
		
		endsideangle = Marionette.PortIn(0, 'nEndSideAngle')
		endsideangle.SetDescription( "End mitre side angle either +ive ot -ive" )
	
		endtopcentred = Marionette.PortIn(False, 'bEndTopCentred')
		endtopcentred.SetDescription( "End mitre top angle centred on shape" )
	
		endsidecentred = Marionette.PortIn(False, 'bEndSideCentred')
		endsidecentred.SetDescription( "End mitre side angle centred on shape" )
	
		followshape = Marionette.PortIn(False, 'bFollowShapeAngle')
		followshape.SetDescription( "Start and end mitres follow shape angle" )
	
		#Output Ports
		mitredef = Marionette.PortOut('Mitredef')
		mitredef.SetDescription( "The resultant mitre type" )
	
	#BEHAVIOR
	
	def RunNode(self):
		def getnumbval(value,defvalue):
			if isinstance(value,(list,tuple)):
				value = value[0]
			if isinstance(value,(int,float)):
				return value
			else:
				return defvalue
	
		def getboolval(bvalue):
			if isinstance(bvalue,list):
				return bvalue[0]
			else:
				return bvalue
	
		#inputs
		starttopangle	 = getnumbval(self.Params.starttopangle.value,0)
		startsideangle   = getnumbval(self.Params.startsideangle.value,0)
		starttopcentred  = getboolval(self.Params.starttopcentred.value)
		startsidecentred = getboolval(self.Params.startsidecentred.value)
		startmitre = 'None'
		if (abs(starttopangle) > 0) and (abs(startsideangle) > 0):
			startmitre = 'Both'
		elif (abs(starttopangle) > 0):
			startmitre = 'Top'
		elif (abs(startsideangle) > 0):
			startmitre = 'Side'
	
		endtopangle	   = getnumbval(self.Params.endtopangle.value,0)
		endsideangle   = getnumbval(self.Params.endsideangle.value,0)
		endtopcentred  = getboolval(self.Params.endtopcentred.value)
		endsidecentred = getboolval(self.Params.endsidecentred.value)
		endmitre = 'None'
		if (abs(endtopangle) > 0) and (abs(endsideangle) > 0):
			endmitre = 'Both'
		elif (abs(starttopangle) > 0):
			endmitre = 'Top'
		elif (abs(endsideangle) > 0):
			endmitre = 'Side'
	
		followshape = getboolval(self.Params.followshape.value)
	
		optionstring = {'MI':{'startmitre':startmitre,'starttopangle':str(starttopangle),'startsideangle':str(startsideangle),'starttopcentred':str(bool(starttopcentred)),'startsidecentred':str(bool(startsidecentred)),'endmitre':endmitre,'endtopangle':str(endtopangle),'endsideangle':str(endsideangle),'endtopcentred':str(bool(endtopcentred)),'endsidecentred':str(bool(endsidecentred)),'mitrefollowshape':str(bool(followshape))
	}}
	
		#outputs
		self.Params.mitredef.value = optionstring