	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Mitres/EP Path Mitre UI.py;
	# Created by Bill Wood 29/8/18
	# Edited Converted to VW 2020 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Mitres UI" )
		this.SetDescription( 'Set start and end mitres for a Linear path (only)' )
	
		#OIP Input Controls
		followshape =  Marionette.OIPControl( 'Mitres follow shape angle', Marionette.WidgetType.Bool, True)
		followshape.SetDescription( "Start and end mitres follow shape angle" )
		
		startseparator = Marionette.OIPControl( 'Start Mitre ', Marionette.WidgetType.Separator, ' ')
		
		starttopangle = Marionette.OIPControl( 'Top Angle', Marionette.WidgetType.RealCoord, 30)
		starttopangle.SetDescription( "Start mitre top angle either +ive ot -ive" )
	
		startsideangle = Marionette.OIPControl( 'Side Angle', Marionette.WidgetType.RealCoord, 30)
		startsideangle.SetDescription( "Start mitre side angle either +ive ot -ive" )
	
		starttopcentred = Marionette.OIPControl( 'Top Angle Centred', Marionette.WidgetType.Bool, True)
		starttopcentred.SetDescription( "Start mitre top angle centred on shape" )
	
		startsidecentred = Marionette.OIPControl( 'Side Angle Centred', Marionette.WidgetType.Bool, True)
		startsidecentred.SetDescription( "Start mitre side angle centred on shape" )
	
		endseparator = Marionette.OIPControl( 'End Mitre ', Marionette.WidgetType.Separator, ' ')
		
		endtopangle = Marionette.OIPControl( 'Top Angle', Marionette.WidgetType.RealCoord, 30)
		endtopangle.SetDescription( "End mitre top angle either +ive ot -ive" )
	
		endsideangle = Marionette.OIPControl( 'Side Angle', Marionette.WidgetType.RealCoord, 30)
		endsideangle.SetDescription( "End mitre top angle either +ive ot -ive" )
	
		endtopcentred = Marionette.OIPControl( 'Top Angle Centred', Marionette.WidgetType.Bool, True)
		endtopcentred.SetDescription( "End mitre top angle centred on shape" )
	
		endsidecentred = Marionette.OIPControl( 'Side Angle Centred', Marionette.WidgetType.Bool, True)
		endsidecentred.SetDescription( "End mitre side angle centred on shape" )
	
		#Output Ports
		shape = Marionette.PortOut('Mitredef')
		shape.SetDescription( "The resultant mitre definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		starttopangle	= self.Params.starttopangle.value
		startsideangle   = self.Params.startsideangle.value
		starttopcentred  = self.Params.starttopcentred.value
		startsidecentred = self.Params.startsidecentred.value
		startmitre = 'None'
		if (abs(starttopangle) > 0) and (abs(startsideangle) > 0):
			startmitre = 'Both'
		elif (abs(starttopangle) > 0):
			startmitre = 'Top'
		elif (abs(startsideangle) > 0):
			startmitre = 'Side'
	
		endtopangle	= self.Params.endtopangle.value
		endsideangle   = self.Params.endsideangle.value
		endtopcentred  = self.Params.endtopcentred.value
		endsidecentred = self.Params.endsidecentred.value
		endmitre = 'None'
		if (abs(endtopangle) > 0) and (abs(endsideangle) > 0):
			endmitre = 'Both'
		elif (abs(starttopangle) > 0):
			endmitre = 'Top'
		elif (abs(endsideangle) > 0):
			endmitre = 'Side'
	
		followshape = self.Params.followshape.value
	
		optionstring = {'MI':{'startmitre':startmitre,'starttopangle':str(starttopangle),'startsideangle':str(startsideangle),'starttopcentred':str(bool(starttopcentred)),'startsidecentred':str(bool(startsidecentred)),'endmitre':endmitre,'endtopangle':str(endtopangle),'endsideangle':str(endsideangle),'endtopcentred':str(bool(endtopcentred)),'endsidecentred':str(bool(endsidecentred)),'mitrefollowshape':str(bool(followshape))
	}}
	
		#outputs
		self.Params.shape.value = optionstring