	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Orientation/EP Pivot.py;
	# Created by Bill Wood 29/7/18
	# Edited Converted to VW 2020 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Pivot" )
		this.SetDescription( 'Select Pivot option for extruded path' )
	
		#OIP Input Controls
		pivotOptions = ['As Shape','Top Left','Top Centre','Top Right','Centre Left','Centre Centre','Centre Right','Bottom Left','Bottom Centre','Bottom Right'
	]
		pivotType = Marionette.OIPControl('Pivot Type', Marionette.WidgetType.Popup, 0, pivotOptions)
		pivotType.SetDescription( "The type of pivot location for an extrude path" )
	
		#Output Ports
		pivot = Marionette.PortOut('Type')
		pivot.SetDescription( "The resultant pivot definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#outputs
		option = self.Params.pivotOptions[self.Params.pivotType.value]
		self.Params.pivot.value = {'PV':option}