	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Orientation/EP Shape Orientation UI.py;
	# Created by Bill Wood 29/7/18
	# Edited Converted to VW 2020 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Shape Orientation UI" )
		this.SetDescription( 'Extrude path plugin shape orientation definition.' )
	
		#OIP Input Controls
		xoffset = Marionette.OIPControl( 'X Offset', Marionette.WidgetType.RealCoord, 0)
		xoffset.SetDescription( "Shape offset in X" )
	
		yoffset = Marionette.OIPControl( 'Y Offset', Marionette.WidgetType.RealCoord, 0)
		yoffset.SetDescription( "Shape offset in Y" )
	
		rotangle = Marionette.OIPControl( 'Angle', Marionette.WidgetType.RealAngle, 0)
		rotangle.SetDescription( "Shape rotation" )
	
		fliphori = Marionette.OIPControl( 'Flip Hori', Marionette.WidgetType.Bool, True)
		fliphori.SetDescription( "Shape flipped in horizontal axis" )
	
		flipvert = Marionette.OIPControl( 'Flip Vert', Marionette.WidgetType.Bool, True)
		flipvert.SetDescription( "Shape flipped in vertical axis" )
			
		pivotOptions = ['As Shape','Top Left','Top Centre','Top Right','Centre Left','Centre Centre','Centre Right','Bottom Left','Bottom Centre','Bottom Right']
	
		pivotType = Marionette.OIPControl('Pivot Type', Marionette.WidgetType.Popup, 0, pivotOptions)
		pivotType.SetDescription( "The type of pivot location for an extrude path" )
	
		#Output Ports
		shape = Marionette.PortOut('orientDef')
		shape.SetDescription( "The resultant shape orientation definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		xoffset  = self.Params.xoffset.value
		yoffset  = self.Params.yoffset.value
		rotangle = self.Params.rotangle.value
		fliphori = self.Params.fliphori.value
		flipvert = self.Params.flipvert.value
		pivotType = self.Params.pivotOptions[self.Params.pivotType.value]
		
		optionstring = {'SO':{'xoffset':str(xoffset),'yoffset':str(yoffset),'shapeangle':str(rotangle),'fliphori':str(bool(fliphori)),'flipvert':str(bool(flipvert)),'shapepivot':pivotType}}
	
		#outputs
		self.Params.shape.value = optionstring