	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Orientation/EP Shape Orientation.py;
	# Created by Bill Wood 29/7/18
	# Edited Converted to VW 2020 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Shape Orientation" )
		this.SetDescription( 'Extrude path plugin shape orientation definition.' )
	
		#Input Ports
		xoffset = Marionette.PortIn(0, 'nXOffset')
		xoffset.SetDescription( "Shape offset in X" )
	
		yoffset = Marionette.PortIn(0, 'nYOffset')
		yoffset.SetDescription( "Shape offset in Y" )
	
		rotangle = Marionette.PortIn(0, 'nAngle')
		rotangle.SetDescription( "Shape rotation" )
	
		fliphori = Marionette.PortIn(False, 'bFlip Hori')
		fliphori.SetDescription( "Shape flipped in horizontal axis" )
	
		flipvert = Marionette.PortIn(False, 'bFlip Vert')
		flipvert.SetDescription( "Shape flipped in vertical axis" )
		
		pivotType = Marionette.PortIn(0,'Pivot Type') #[]
		pivotType.SetDescription( "The type of pivot location for an extrude path" )
	
		#Output Ports
		shape = Marionette.PortOut('orientDef')
		shape.SetDescription( "The resultant shape orientation definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		def getnumbval(value,defvalue):
			if isinstance(value,(list,tuple)):
				value = value[0]
			if isinstance(value,(int,float)):
				return value
			else:
				return defvalue
	
		def getboolval(bvalue):
			if isinstance(bvalue,list):
				return bvalue[0]
			else:
				return bvalue
	
		#inputs
		xoffset   = getnumbval(self.Params.xoffset.value,0)
		yoffset   = getnumbval(self.Params.yoffset.value,0)
		rotangle  = getnumbval(self.Params.rotangle.value,0) # PIO sets min/max values
		fliphori  = getboolval(self.Params.fliphori.value)
		flipvert  = getboolval(self.Params.flipvert.value)
		pivotType = getboolval(self.Params.pivotType.value)
	
		if isinstance(pivotType,dict) and ('PV' in pivotType):
			pivotoption = pivotType['PV']
		else:
			pivotoption = 'As Shape'
		
		optionstring = {'SO':{'xoffset':str(xoffset),'yoffset':str(yoffset),'shapeangle':str(rotangle),'fliphori':str(bool(fliphori)),'flipvert':str(bool(flipvert)),'shapepivot':pivotoption}}
		vs.AlrtDialog(str(optionstring))
		#outputs
		self.Params.shape.value = optionstring