	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Shapes/Angle/EP Angle Custom.py;
	# Created by Bill Wood 29/7/18
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		nodename = "EP Angle Custom"
		nodedesc = 'Set a custom Angle section size'
	
		def getsizedeffirst(filename):
			import os
			fref = os.path.join(vs.GetFolderPath(20) , filename )
			content = []
			contentvals = []
			if os.path.exists(fref):
	
				f = open(fref)
				upi  = f.readline()
				line = f.readline()
				line  = line.splitlines() # omit line break
				sline = line[0].split('\t')
				sizeref = sline.pop(0)
	
				f.close()
			else:
				sizeref = 0
			return sizeref
	
		def getsectionstring(self,a,b,t,rta,rtb,rf,sharpCorners):
			nodetype   = 'Angle'
			shapetype  = 'Shape Plugin'
			sep = chr(92) # backslash
	
			impunits = ['Inches','Feet','Feet & Inches','Yards','Miles']
			if vs.GetPrefString(153) in impunits:
				nodeseries = 'Inches'
				filename = 'StructShape_Angle-Inch.txt'
			else:
				nodeseries = 'Metric'
				filename = 'StructShape_Angle-Metric.txt'
	
			params = '\\a\\b\\t\\rtA\\rtB\\rf\\'
			paramvals = sep+str(a)+sep+str(b)+sep+str(t)+sep+str(rta)+sep+str(rtb)+sep+str(rf)+sep
			upi = vs.GetPrefReal(152)
	
			# EP Popup references
			series = ['Metric','Inch','BSI','DIN','JIS','ANZ']
			funcs  = ['WFlange','IBeam','Channel','Angle','Tee','SqTubing','RectTubing','RoundTubing','BulbFlat','ZSection']
			types  = ['Wide Flange','I-Beam','Channel','Angle','Tee','Square Tubing','Rectangular Tubing','Round Tubing','Bulb Flat','Z-Section']
	
			# <pioclass = 1>_<pioname>_<piotype>_<pioname filref>_<seriesno>_<seriesname>_<sizeno>_<sizename>_<customset 0 = FALSE 1 = TRUE>_
			typeref = types.index(nodetype)
			funcref = funcs[typeref]
	
			seriesref = series.index(nodeseries)
			seriesname = series[seriesref]
			
			sizename = self.Params.getsizedeffirst(filename)
	
			if sizename:
				# Example  _1_Wide Flange_1_WFlange_1_Metric_268_W100 x 19.3_0_
				shapedef = nodetype + ' ' + seriesname + ' Custom'
				piodef = sep +'1'+ sep + types[typeref] + sep + str(typeref+1) + sep + funcs[typeref] + sep + str(seriesref+1) + sep + seriesname + sep + '1' + sep + sizename + sep + '1' + sep # last 1 is custom size
				nodedefinition = {'IS':{'shapetype':shapetype,'shapedef':shapedef,'__pioname':nodetype,'__piodef':piodef,'__sharpcorners':str(bool(sharpCorners)),'__noholes':'True','__upi':upi,'__params':params,'__paramvals':paramvals}}
			else:
				nodedefinition = 0
	
			return nodedefinition
		
		#Name
		this = Marionette.Node( nodename )
		this.SetDescription( nodedesc )
		
		#OIP Input Controls
		a = Marionette.OIPControl( 'Length of Side A', Marionette.WidgetType.RealCoord, 101.6)
		a.SetDescription('The length of angle horizontal leg')
	
		b = Marionette.OIPControl( 'Length of Side B', Marionette.WidgetType.RealCoord, 76.2)
		b.SetDescription('The length of angle vertical leg')
	
		t = Marionette.OIPControl( 'Thickness', Marionette.WidgetType.RealCoord, 6.35)
		t.SetDescription('The thickness of angle legs')
	
		rta = Marionette.OIPControl( 'Toe R (Side A)', Marionette.WidgetType.RealCoord, 6.35)
		rta.SetDescription('The toe radius of the angle horizontal leg')
	
		rtb = Marionette.OIPControl( 'Toe R (Side B)', Marionette.WidgetType.RealCoord, 6.35)
		rtb.SetDescription('The toe radius of the angle vertical leg')
		
		rf = Marionette.OIPControl( 'Fillet Radius', Marionette.WidgetType.RealCoord, 7.938)
		rf.SetDescription('The fillet radius of the angle')
	
		sharpCorners = Marionette.OIPControl( 'Sharp corners', Marionette.WidgetType.Bool, False)
		sharpCorners.SetDescription( "Section shape to replace fillets with sharp corners" )
	
		#Output Ports
		sectdef = Marionette.PortOut('Shape')
		sectdef.SetDescription( "The resultant shape definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		a	= self.Params.a.value
		b	= self.Params.b.value
		t	= self.Params.t.value
		rta  = self.Params.rta.value
		rtb  = self.Params.rtb.value
		rf   = self.Params.rf.value
		valuetest = ((a > 0) and (b > 0) and (t > 0) and (rta >= 0) and (rtb >= 0) and (rf >= 0))
		if valuetest:
			sharpCorners = self.Params.sharpCorners.value
	
			#outputs
			#_a_b_t_rf_rtA_rtB
			sectionstring = self.Params.getsectionstring(self,a,b,t,rta,rtb,rf,sharpCorners)
		else:
			sectionstring = 0
	
		self.Params.sectdef.value = sectionstring