	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Shapes/Other/EP Arc.py;
	# Created by Bill Wood 29/7/18
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Arc" )
		this.SetDescription( 'Extrude path arc shape definition.' )
	
		#OIP Input Controls
		arcwidth = Marionette.OIPControl( 'X Diameter', Marionette.WidgetType.RealCoord, 1)
		arcwidth.SetDescription( "Shape circle X diameter" )
	
		archeight = Marionette.OIPControl( 'Y Diameter', Marionette.WidgetType.RealCoord, 1)
		archeight.SetDescription( "Shape circle Y diameter" )
	
		arcthick = Marionette.OIPControl( 'Thickness', Marionette.WidgetType.RealCoord, 0)
		arcthick.SetDescription( "Shape circle thickness" )
	
		arcstartang = Marionette.OIPControl( 'Start Angle', Marionette.WidgetType.RealAngle, 0)
		arcstartang.SetDescription( "Shape arc start angle" )
	
		arcendang = Marionette.OIPControl( 'End Angle', Marionette.WidgetType.RealAngle, 90)
		arcendang.SetDescription( "Shape arc end angle" )
	
		#Output Ports
		shape = Marionette.PortOut('Shape')
		shape.SetDescription( "The resultant arc shape" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		arcwidth  = self.Params.arcwidth.value
		archeight = self.Params.archeight.value
		arcthick  = self.Params.arcthick.value
		arcstartang  = self.Params.arcstartang.value
		arcendang	= self.Params.arcendang.value
	
		#outputs
		self.Params.shape.value = {'IS':{'shapedef':'','shapetype':'Arc','__standardshape':'3', 'val1':str(arcwidth),'val2':str(archeight),'thickness':str(arcthick),'startangle':str(arcstartang),'endangle':str(arcendang)}}