	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Shapes/Other/EP Polygon.py;
	# Created by Bill Wood 29/7/18
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Polygon" )
		this.SetDescription( 'Extrude path polygon shape definition.' )
	
		#OIP Input Controls
		polydiam = Marionette.OIPControl( 'Diameter', Marionette.WidgetType.RealCoord, 1)
		polydiam.SetDescription( "Shape polygon diameter" )
		
		polythick = Marionette.OIPControl( 'Thickness', Marionette.WidgetType.RealCoord, 0)
		polythick.SetDescription( "Shape polygon thickness" )
	
		polysides = Marionette.OIPControl( 'No of Sides', Marionette.WidgetType.Int, 3)
		polysides.SetDescription( "Shape polygon number of sides" )
	
	
		#Output Ports
		shape = Marionette.PortOut('Shape')
		shape.SetDescription( "The resultant polygon shape" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		polydiam  = self.Params.polydiam.value
		polythick = self.Params.polythick.value
		polysides = self.Params.polysides.value
	
		#outputs
		if polysides > 2:
			result = {'IS':{'shapedef':'','shapetype':'Polygon','__standardshape':'4', 'val1':str(polydiam),'val2':'','thickness':str(polythick),'polysides':str(polysides)}}
		else:
			result = 0
		self.Params.shape.value = result