	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Shapes/Square Tubing/EP Square Tubing Custom.py;
	# Created by Bill Wood 29/7/18
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		nodename = "EP Square Tubing Custom"
		nodedesc = 'Set a Square Tubing Custom section size'
	
		def getsizedeffirst(filename):
			import os
			fref = os.path.join(vs.GetFolderPath(20) , filename )
			content = []
			contentvals = []
			if os.path.exists(fref):
	
				f = open(fref)
				upi  = f.readline()
				line = f.readline()
				line  = line.splitlines() # omit line break
				sline = line[0].split('\t')
				sizeref = sline.pop(0)
	
				f.close()
			else:
				sizeref = 0
			return sizeref
	
		def getsectionstring(self,a,t,ri,sharpCorners,noholes):
			nodetype   = 'Square Tubing'
			shapetype  = 'Shape Plugin'
			sep = chr(92) # backslash
	
			impunits = ['Inches','Feet','Feet & Inches','Yards','Miles']
			if vs.GetPrefString(153) in impunits:
				nodeseries = 'Inch'
				filename = 'StructShape_SqTubing-Inch.txt'
			else:
				nodeseries = 'Metric'
				filename = 'StructShape_SqTubing-Metric.txt'
	
			params = '\\a\\b\\t\\ri\\'
			paramvals = sep+str(a)+sep+str(a)+sep+str(t)+sep+str(ri)+sep
			upi = vs.GetPrefReal(152)
	
			# EP Popup references
			series = ['Metric','Inch','BSI','DIN','JIS','ANZ']
			funcs  = ['WFlange','IBeam','Channel','Angle','Tee','SqTubing','RectTubing','RoundTubing','BulbFlat','ZSection']
			types  = ['Wide Flange','I-Beam','Channel','Angle','Tee','Square Tubing','Rectangular Tubing','Round Tubing','Bulb Flat','Z-Section']
	
			# <pioclass = 1>_<pioname>_<piotype>_<pioname filref>_<seriesno>_<seriesname>_<sizeno>_<sizename>_<customset 0 = FALSE 1 = TRUE>_
			typeref = types.index(nodetype)
			funcref = funcs[typeref]
	
			seriesref = series.index(nodeseries)
			seriesname = series[seriesref]
			
			sizename = self.Params.getsizedeffirst(filename)
	
			if sizename:
				# Example  _1_Wide Flange_1_WFlange_1_Metric_268_W100 x 19.3_0_
				shapedef = nodetype + ' ' + seriesname + ' Custom'
				piodef = sep +'1'+ sep + types[typeref] + sep + str(typeref+1) + sep + funcs[typeref] + sep + str(seriesref+1) + sep + seriesname + sep + '1' + sep + sizename + sep + '1' + sep # last 1 is custom size
				nodedefinition = {'IS':{'shapetype':shapetype,'shapedef':shapedef,'__pioname':nodetype,'__piodef':piodef,'__sharpcorners':str(bool(sharpCorners)),'__noholes':str(bool(noholes)),'__upi':upi,'__params':params,'__paramvals':paramvals}}
			else:
				nodedefinition = 0
	
			return nodedefinition
		
		#Name
		this = Marionette.Node( nodename )
		this.SetDescription( nodedesc )
		
		#OIP Controls
		
		a = Marionette.OIPControl( 'Width', Marionette.WidgetType.RealCoord, 50.8)
		a.SetDescription('The width of square tubing')
	
		t = Marionette.OIPControl( 'Wall Thickness', Marionette.WidgetType.RealCoord, 4.763)
		t.SetDescription('The wall thickness of rectangular tubing')
	
		ri = Marionette.OIPControl( 'Inside Fillet Radius', Marionette.WidgetType.RealCoord, 4.7625)
		ri.SetDescription('The inside fillet radius of rectangular tubing')
	
		sharpCorners = Marionette.OIPControl( 'Sharp corners', Marionette.WidgetType.Bool, False)
		sharpCorners.SetDescription( "Section shape to replace fillets with sharp corners" )
	
		omithole = Marionette.OIPControl( 'No Hole', Marionette.WidgetType.Bool, False)
		omithole.SetDescription( "Section shape to has hole omitted" )
	
		#Output Ports
		sectdef = Marionette.PortOut('Shape')
		sectdef.SetDescription( "The resultant shape definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		a	= self.Params.a.value
		t	= self.Params.t.value
		ri  = self.Params.ri.value
	
		valuetest = ((a > 0) and (t > 0)  and (ri >= 0))
		if valuetest:
			sharpCorners = self.Params.sharpCorners.value
			omithole = self.Params.omithole.value
	
			#outputs
			sectionstring = self.Params.getsectionstring(self,a,t,ri,sharpCorners,omithole)
		else:
			sectionstring = 0
	
		self.Params.sectdef.value = sectionstring