	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Shapes/Symbol/EP Scaled Symbol.py;
	# Created by Bill Wood 29/7/18
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Scaled Symbol" )
		this.SetDescription( 'Extrude path symbol shape definition.' )
	
		#OIP Input Controls
		symname = Marionette.OIPControl( 'Symbol Name', Marionette.WidgetType.Text, 'Shape default-1')
		symname.SetDescription( "Shape symbol name" )
	
		scaleX = Marionette.OIPControl( 'Scale in X', Marionette.WidgetType.Real, 1.0)
		scaleX.SetDescription('Scale symbol content in X ( as 1/value)')
	
		scaleY = Marionette.OIPControl( 'Scale in Y', Marionette.WidgetType.Real, 1.0)
		scaleY.SetDescription('Scale symbol content in Y')
		
		useshapeclasses = Marionette.OIPControl( 'Use Shape Classes', Marionette.WidgetType.Bool, False)
		useshapeclasses.SetDescription( "Use shape classes in symbol" )
	
	
		#Output Ports
		shape = Marionette.PortOut('Shape')
		shape.SetDescription( "The resultant symbol shape" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		symname = self.Params.symname.value
	
	#	setpioparam('__symbolname',extrudedefs.symbolname);
	#	setpioparam('__useshapeclasses',concat(extrudedefs.useshapeclasses));
	#	setpioparam('shapedef',extrudedefs.symbolname);
	#	setpioparam('__customsymbol',extrudedefs.customsymbol);
	#	setpioparam('__customscaleX',extrudedefs.customscaleX);
	#	setpioparam('__customscaleY',extrudedefs.customscaleY);
	
		symH = vs.GetObject(symname)
		if vs.GetTypeN(symH) == 16:
			parentH = vs.GetParent(symH)
			parentname = vs.GetName(parentH)
			if (vs.GetTypeN(parentH) == 92) and (parentname == 'Shape Symbols'):
				scaleX  = self.Params.scaleX.value
				if (scaleX < 0):	# convert negative to 1 / scale
					scaleX = -1/scaleX
				elif (scaleX == 0): # convert zero scale to 1
					scaleX = 1
	
				scaleY  = self.Params.scaleY.value
				if (scaleY < 0):	# convert negative to 1 / scale
					scaleY = -1/scaleY
				elif (scaleY == 0): # convert zero scale to 1
					scaleY = 1
	
				useshapeclasses = self.Params.useshapeclasses.value
				result = {'IS':{'shapedef':symname,'shapetype':'Shape Symbol','__symbolname':symname,'__customscaleX':scaleX,'__customscaleY':scaleY,'__useshapeclasses':str(bool(useshapeclasses))}}
			else:
				result = 'Symbol not in Shape Symbols folder'
		else:
			result = 'Not a symbol'
		  	
		#outputs
		self.Params.shape.value = result