	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Shapes/Symbol/EP Symbol.py;
	# Created by Bill Wood 29/7/18
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "EP Symbol" )
		this.SetDescription( 'Extrude path symbol shape definition.' )
	
		#OIP Input Controls
		symname = Marionette.OIPControl( 'Symbol Name', Marionette.WidgetType.Text, 'Shape default-1')
		symname.SetDescription( "Shape symbol name" )
		
		useshapeclasses = Marionette.OIPControl( 'Use Shape Classes', Marionette.WidgetType.Bool, False)
		useshapeclasses.SetDescription( "Use shape classes in symbol" )
	
	
		#Output Ports
		shape = Marionette.PortOut('Shape')
		shape.SetDescription( "The resultant symbol shape" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		symname  = self.Params.symname.value
		useshapeclasses = self.Params.useshapeclasses.value
	
	#	setpioparam('__symbolname',extrudedefs.symbolname);
	#	setpioparam('__useshapeclasses',concat(extrudedefs.useshapeclasses));
	#	setpioparam('shapedef',extrudedefs.symbolname);
	#	setpioparam('__customsymbol',extrudedefs.customsymbol);
	
		symH = vs.GetObject(symname)
		if vs.GetTypeN(symH) == 16:
			parentH = vs.GetParent(symH)
			parentname = vs.GetName(parentH)
			if (vs.GetTypeN(parentH) == 92) and (parentname == 'Shape Symbols'):
				result = {'IS':{'shapedef':symname,'shapetype':'Shape Symbol','__symbolname':symname,'__useshapeclasses':str(bool(useshapeclasses))}}
			else:
				result = 'Symbol not in Shape Symbols folder'
		else:
			result = 'Not a symbol'
		  	
		#outputs
		self.Params.shape.value = result