	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Shapes/Tee/EP Tee DIN.py;
	# Created by Bill Wood 29/7/18
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		nodename = "EP Tee DIN"
		nodedesc = 'Select a Tee DIN section size'
	
		def getsectionstring(upi,secttype,sizename,sizedefs,sharpcorners,noholes):
			nodetype = 'Tee'
			nodeseries = 'DIN'
			shapetype  = 'Shape Plugin'
			sep = chr(92) # backslash
	
			#Old settings 210406
			#params = '\\d\\w\\tw\\tf\\rf\\rt\\slope\\slope_flange\\r_Toe\\'
			#paramvals = sep+sizedefs[0]+sep+sizedefs[1]+sep+sizedefs[2]+sep+sizedefs[3]+sep+sizedefs[8]+sep+sizedefs[7]+sep+sizedefs[4]+sep+sizedefs[5]+sep+sizedefs[6]+sep
	
			params = '\\d\\w\\tw\\tf\\slope\\slope_flange\\r_Toe\\rt\\rf\\'
			# reorder 1=1 2=2 3=3 4=4 5=6 6=7 7=8 8=9 9=5 (paramval = fileval)
			paramvals = sep+sizedefs[0]+sep+sizedefs[1]+sep+sizedefs[2]+sep+sizedefs[3]+sep+sizedefs[5]+sep+sizedefs[6]+sep+sizedefs[7]+sep+sizedefs[8]+sep+sizedefs[4]+sep
	
			# EP Popup references
			series = ['Metric','Inch','BSI','DIN','JIS','ANZ']
			funcs  = ['WFlange','IBeam','Channel','Angle','Tee','SqTubing','RectTubing','RoundTubing','BulbFlat','ZSection']
			types  = ['Wide Flange','I-Beam','Channel','Angle','Tee','Square Tubing','Rectangular Tubing','Round Tubing','Bulb Flat','Z-Section']
	
			# <pioclass = 1>_<pioname>_<piotype>_<pioname filref>_<seriesno>_<seriesname>_<sizeno>_<sizename>_<customset 0 = FALSE 1 = TRUE>_
			typeref = types.index(nodetype)
			funcref = funcs[typeref]
			seriesref = series.index(nodeseries)
			seriesname = series[seriesref]
	
			shapedef = nodetype +' '+ seriesname +' '+ sizename
	
			# Example  _1_Wide Flange_1_WFlange_1_Metric_268_W100 x 19.3_0_
			piodef = sep +'1'+ sep + types[typeref] + sep + str(typeref+1) + sep + funcs[typeref] + sep + str(seriesref+1) + sep + seriesname + sep + str(secttype+1) + sep + sizename + sep + '0'+ sep
			nodedefinition = {'IS':{'shapetype':shapetype,'shapedef':shapedef,'__pioname':nodetype,'__piodef':piodef,'__sharpcorners':str(bool(sharpcorners)),'__noholes':str(bool(noholes)),'__upi':upi,'__params':params,'__paramvals':paramvals}}
	
			return nodedefinition
	
		def getpopupcontent():
			import os
			fref = os.path.join(vs.GetFolderPath(20) , 'StructShape_Tee-DIN.txt' )
			content = []
			contentvals = []
			if os.path.exists(fref):
	
				f = open(fref)
				upi  = f.readline().splitlines()[0] # omit line break
				line = f.readline()
				while line:
					line  = line.splitlines() # omit line break
					sline = line[0].split('\t')
					sizeref = sline.pop(0)
					content.append(sizeref)
					contentvals.append(sline)
					line = f.readline()
				f.close()
			else:
				content = 0
			# upi has 9 trailing tabs in definition file
			return (str(float(upi)),content,contentvals)
	
		
		#Name
		this = Marionette.Node( nodename )
		this.SetDescription( nodedesc )
		
		#OIP Controls
		(upi,sectionSizes,sizeVals) = getpopupcontent()
		sectionType = Marionette.OIPControl('Section Type', Marionette.WidgetType.Popup, 0, sectionSizes )
		sectionType.SetDescription( "List of valid section types" )
	
		sharpCorners = Marionette.OIPControl( 'Sharp corners', Marionette.WidgetType.Bool, False)
		sharpCorners.SetDescription( "Section shape to replace fillets with sharp corners" )
	
		#Output Ports
		sectdef = Marionette.PortOut('Shape')
		sectdef.SetDescription( "The resultant shape definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		sectionType = self.Params.sectionType.value
		sectionName = self.Params.sectionSizes[sectionType]
		sharpCorners = self.Params.sharpCorners.value
	
		sizeDefinition   = self.Params.sizeVals[sectionType]
		upi = self.Params.upi
	
		#outputs
		sectionstring = self.Params.getsectionstring(upi,sectionType,sectionName,sizeDefinition,sharpCorners,False)
		self.Params.sectdef.value = sectionstring