	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Extrude Path/Shapes/Wide Flange/EP Wide Flange Custom.py;
	# Created by Bill Wood 29/7/18
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		nodename = "EP Wide Flange Custom"
		nodedesc = 'Set a custom Tee section size'
	
		def getsizedeffirst(filename):
			import os
			fref = os.path.join(vs.GetFolderPath(20) , filename )
			content = []
			contentvals = []
			if os.path.exists(fref):
	
				f = open(fref)
				upi  = f.readline()
				line = f.readline()
				line  = line.splitlines() # omit line break
				sline = line[0].split('\t')
				sizeref = sline.pop(0)
	
				f.close()
			else:
				sizeref = 0
			return sizeref
	
		def getsectionstring(self,d,w,wB,tw,tf,rf,sharpCorners,noholes):
			nodetype   = 'Tee'
			shapetype  = 'Shape Plugin'
			sep = chr(92) # backslash
	
			impunits = ['Inches','Feet','Feet & Inches','Yards','Miles']
			if vs.GetPrefString(153) in impunits:
				nodeseries = 'Inch'
				filename = 'StructShape_WFlange-Inch.txt'
			else:
				nodeseries = 'Metric'
				filename = 'StructShape_WFlange-Metric.txt'
	
			params = '\\d\\w\\wB\\tw\\tf\\rf\\'
			paramvals = sep+str(d)+sep+str(w)+sep+str(wB)+sep+str(tw)+sep+str(tf)+sep+str(rf)+sep
			upi = vs.GetPrefReal(152)
	
			# EP Popup references
			series = ['Metric','Inch','BSI','DIN','JIS','ANZ']
			funcs  = ['WFlange','IBeam','Channel','Angle','Tee','SqTubing','RectTubing','RoundTubing','BulbFlat','ZSection']
			types  = ['Wide Flange','I-Beam','Channel','Angle','Tee','Square Tubing','Rectangular Tubing','Round Tubing','Bulb Flat','Z-Section']
	
			# <pioclass = 1>_<pioname>_<piotype>_<pioname filref>_<seriesno>_<seriesname>_<sizeno>_<sizename>_<customset 0 = FALSE 1 = TRUE>_
			typeref = types.index(nodetype)
			funcref = funcs[typeref]
	
			seriesref = series.index(nodeseries)
			seriesname = series[seriesref]
			
			sizename = self.Params.getsizedeffirst(filename)
	
			if sizename:
				# Example  _1_Wide Flange_1_WFlange_1_Metric_268_W100 x 19.3_0_
				shapedef = nodetype + ' ' + seriesname + ' Custom'
				piodef = sep +'1'+ sep + types[typeref] + sep + str(typeref+1) + sep + funcs[typeref] + sep + str(seriesref+1) + sep + seriesname + sep + '1' + sep + sizename + sep + '1' + sep # last 1 is custom size
				nodedefinition = {'IS':{'shapetype':shapetype,'shapedef':shapedef,'__pioname':nodetype,'__piodef':piodef,'__sharpcorners':str(bool(sharpCorners)),'__noholes':str(bool(noholes)),'__upi':upi,'__params':params,'__paramvals':paramvals}}
			else:
				nodedefinition = 0
	
			return nodedefinition
		
		#Name
		this = Marionette.Node( nodename )
		this.SetDescription( nodedesc )
		
		#OIP Controls
		d = Marionette.OIPControl( 'Depth', Marionette.WidgetType.RealCoord, 159.512)
		d.SetDescription('The depth of wide flange section')
	
		w = Marionette.OIPControl( 'Flange Width (Top)', Marionette.WidgetType.RealCoord, 102.362)
		w.SetDescription('The width of wide flange section')
	
		wB = Marionette.OIPControl( 'Flange Width (Bottom)', Marionette.WidgetType.RealCoord, 102.362)
		wB.SetDescription('The width of wide flange section')
	
		tw = Marionette.OIPControl( 'Web Thickness', Marionette.WidgetType.RealCoord, 6.604)
		tw.SetDescription('The thickness of wide flange section')
	
		tf = Marionette.OIPControl( 'Flange Thickness', Marionette.WidgetType.RealCoord, 10.287)
		tf.SetDescription('The thickness of wide flange section')
	
		rf = Marionette.OIPControl( 'Fillet Radius', Marionette.WidgetType.RealCoord, 6.35)
		rf.SetDescription('The fillet radius between flange and web')
	
		sharpCorners = Marionette.OIPControl( 'Sharp corners', Marionette.WidgetType.Bool, False)
		sharpCorners.SetDescription( "Section shape to replace fillets with sharp corners" )
	
		#Output Ports
		sectdef = Marionette.PortOut('Shape')
		sectdef.SetDescription( "The resultant shape definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
		d  = self.Params.d.value
		w  = self.Params.w.value
		wB = self.Params.wB.value
		tw = self.Params.tw.value
		tf = self.Params.tf.value
		rf = self.Params.rf.value
	
		valuetest = ((d > 0) and (w > 0) and (wB > 0) and (tw > 0) and (tf > 0) and (rf >= 0))
		if valuetest:
			sharpCorners = self.Params.sharpCorners.value
	
			#outputs
			sectionstring = self.Params.getsectionstring(self,d,w,wB,tw,tf,rf,sharpCorners,False)
		else:
			sectionstring = 0
	
		self.Params.sectdef.value = sectionstring