	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Panels/Definition/Panel Definiton UI.py;
	# Created by Bill Wood 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "Panel Definition UI" )
		this.SetDescription( 'Set panel definition' )
	
		#Input Ports
		sectiontype = Marionette.OIPControl('Panel Shape', Marionette.WidgetType.Popup, 0, ['Flat','Pyramidal','Curved','Cushion'] )
		sectiontype.SetDescription( "List of valid panel types" )
	
		#OIP Input Controls
		solid = Marionette.OIPControl( 'Solid format', Marionette.WidgetType.Bool, False)
		solid.SetDescription( "Set panel with solid body" )
	
		bulge = Marionette.OIPControl( 'Bulge', Marionette.WidgetType.RealCoord, 50.0)
		bulge.SetDescription('Panel bulge at peak (minimum 50mm) not applicable to Flat')
	
		edgeoffset = Marionette.OIPControl( 'Edge Offset', Marionette.WidgetType.RealCoord, 0.0)
		edgeoffset.SetDescription('Panel edge offset')
	
		hgtoffset = Marionette.OIPControl( 'Height Offset', Marionette.WidgetType.RealCoord, 0.0)
		hgtoffset.SetDescription('Panel height offset')
	
		bezelangle = Marionette.OIPControl( 'Bezel Angle', Marionette.WidgetType.RealAngle, 0.0)
		bezelangle.SetDescription('Panel bezel angle (maximum 85deg) not applicable to Cushion')
	
		thickness = Marionette.OIPControl( 'Thickness', Marionette.WidgetType.RealCoord, 2.0)
		thickness.SetDescription('Panel thickness (minimum 2mm)')
	
		gasket = Marionette.OIPControl( 'With gaskets', Marionette.WidgetType.Bool, False)
		gasket.SetDescription( "Set panel with gaskets" )
	
		gasketthick = Marionette.OIPControl( 'Gasket Thickness', Marionette.WidgetType.RealCoord, 2.0)
		gasketthick.SetDescription('Panel gasket thickness (minimum 2mm)')
	
		gasketextend = Marionette.OIPControl( 'Gasket Extension', Marionette.WidgetType.RealCoord, 0.0)
		gasketextend.SetDescription('Panel gasket extension (greater than zero)')
	
		gasketclass = Marionette.OIPControl('Gasket Class', Marionette.WidgetType.Popup, 0, ['Panel-Gasket-Glass','Panel-Gasket-Solid','Panel-Gasket-1','Panel-Gasket-2','Panel-Gasket-3','Panel-Gasket-4','Panel-Gasket-5'] )
		gasketclass.SetDescription( "List of valid gasket classes" )
	
		flipsides = Marionette.OIPControl( 'Flip sides', Marionette.WidgetType.Bool, False)
		flipsides.SetDescription( "Draw panel on opposite side of shape not applicable to Cushion" )
	
		#Output Ports
		paneldef = Marionette.PortOut('PanelDef')
		paneldef.SetDescription( "The resultant panel definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		paneldef = {'panelshape' : str(self.Params.sectiontype.value),
		'paneltype'  : 'Single Thickness', # for flat option
		'solid' : str(bool(self.Params.solid.value)),
		'bulge' : str(self.Params.bulge.value),
		'edgeoffset' : str(self.Params.edgeoffset.value),
		'hgtoffset'  : str(self.Params.hgtoffset.value),
		'bezelangle' : str(self.Params.bezelangle.value),
		'thickness'  : str(self.Params.thickness.value),
		'flipsides'  : str(bool(self.Params.flipsides.value)),
		'withgaskets' : str(bool(self.Params.gasket.value)),
		'gasketthick' :str(self.Params.gasketthick.value),
		'gasketextend':str(self.Params.gasketextend.value),
		'gasketclass' :str(self.Params.gasketclass.value)
		}
	
		result = {'PNP' : paneldef}
	
		#outputs
		self.Params.paneldef.value = result
	