	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Panels/Definition/Pyramid Panel Definition.py;
	# Created by Bill Wood 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	
	#APPEARANCE
		#Name
		this = Marionette.Node( "Pyramid Panel Definition" )
		this.SetDescription( 'Pyramid Panel Definition.' )
	
		#Input Ports
		solid = Marionette.PortIn(False, 'bSolid')
		solid.SetDescription( "Make panel solid" )
	
		bulge = Marionette.PortIn(0, 'nBulge')
		bulge.SetDescription( "Panel bulge at peak" )
	
		edgeoffset = Marionette.PortIn(0, 'nEdge Offset')
		edgeoffset.SetDescription( "Panel edge offset" )
		
		hgtoffset = Marionette.PortIn(0, 'nHgt Offset')
		hgtoffset.SetDescription( "Panel height offset" )
	
		bezelangle = Marionette.PortIn(0, 'nBezel Angle')
		bezelangle.SetDescription( "Panel edge bezel angle" )
		
		thickness = Marionette.PortIn(0, 'nAvg Thickness')
		thickness.SetDescription( "Panel average thickness" )
	
		gasket = Marionette.PortIn(0, 'Gasketdef')
		gasket.SetDescription( "Panel gasket definition" )
	
		flipsides = Marionette.PortIn(False, 'bFlip Sides')
		flipsides.SetDescription( "Flip which side the panel is drawn" )
	
		#Output Ports
		paneldef = Marionette.PortOut('PanelDef')
		paneldef.SetDescription( "The panel definition" )
	
	#BEHAVIOR
		this.SetLinksObjects()
	
	def RunNode(self):
		def getboolval(bvalue):
			if isinstance(bvalue,list):
				return bvalue[0]
			else:
				return bvalue
	
		def getnumbval(value,defvalue):
			if isinstance(value,(list,tuple)):
				value = value[0]
			if isinstance(value,(int,float)):
				return value
			else:
				return defvalue
	
		#inputs
		gasketdef = self.Params.gasket.value
		if isinstance(gasketdef,list) and ('PNG' in gasketdef[0]):
			gasket = True
			gasketdef = gasketdef[0]['PNG']
		else:
			gasket = False
		
		bulge	   = getnumbval(self.Params.bulge.value,0)
		edgeoffset = getnumbval(self.Params.edgeoffset.value,0)
		hgtoffset  = getnumbval(self.Params.hgtoffset.value,0)
		bezelangle = getnumbval(self.Params.bezelangle.value,0)
		thickness  = getnumbval(self.Params.thickness.value,0)
		solid	   = getboolval(self.Params.solid.value)
		flipsides  = getboolval(self.Params.flipsides.value)
	
		paneldef = {'panelshape' : 'Pyramidal',
		'solid' : str(bool(solid)),
		'bulge' : str(bulge),
		'edgeoffset' : str(edgeoffset),
		'hgtoffset'  : str(hgtoffset),
		'bezelangle' : str(bezelangle),
		'thickness'  : str(thickness),
		'flipsides'  : str(bool(flipsides)),
		'withgaskets' : str(gasket)
		}
		
		if gasket:
			paneldef.update(gasketdef)
	
		result = {'PNP' : paneldef}
	
		#outputs
		self.Params.paneldef.value = result