	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Panels/Definition/Styled Flat Panel Definition.py;
	# Created by Bill Wood 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	
	#APPEARANCE
		#Name
		this = Marionette.Node( "Styled Flat Panel Definition" )
		this.SetDescription( 'Set flat styled panel definition' )
	
		#Input Ports
		edgeoffset = Marionette.PortIn(0, 'nEdge Offset')
		edgeoffset.SetDescription( "Panel edge offset" )
		
		hgtoffset = Marionette.PortIn(0, 'nHgt Offset')
		hgtoffset.SetDescription( "Panel height offset" )
	
		bezelangle = Marionette.PortIn(0, 'nBezel Angle')
		bezelangle.SetDescription( "Panel edge bezel angle" )
		
		stylename = Marionette.PortIn(0, 'sStylename')
		stylename.SetDescription( "Panel style definition" )
	
		stepstyleset = Marionette.PortIn(False, 'bStepped Style')
		stepstyleset.SetDescription( "Panel style stepped rather than bevelled for core > 1" )
		
		gasket = Marionette.PortIn(0, 'Gasketdef')
		gasket.SetDescription( "Panel gasket definition" )
	
		flipsides = Marionette.PortIn(False, 'bFlip Sides')
		flipsides.SetDescription( "Flip which side the panel is drawn" )
	
		#Output Ports
		paneldef = Marionette.PortOut('PanelDef')
		paneldef.SetDescription( "Styled panel definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		def getboolval(bvalue):
			if isinstance(bvalue,list):
				return bvalue[0]
			else:
				return bvalue
	
		def getnumbval(value,defvalue):
			if isinstance(value,(list,tuple)):
				value = value[0]
			if isinstance(value,(int,float)):
				return value
			else:
				return defvalue
	
		#inputs
		stylename = self.Params.stylename.value
		if not stylename:
			stylename = 'Panel Single Glazed'
	
		gasketdef = self.Params.gasket.value
		if isinstance(gasketdef,list) and ('PNG' in gasketdef[0]):
			gasket = True
			gasketdef = gasketdef[0]['PNG']
			gasketthick  = gasketdef['gasketthick']
			gasketextend = gasketdef['gasketextend']
			gasketclass  = gasketdef['gasketclass']
		else:
			gasket = False
			gasketthick = '0'
			gasketextend = '0'
			gasketclass = 'Panel-Gasket-Glass'
	
		edgeoffset   = getnumbval(self.Params.edgeoffset.value,0)
		hgtoffset	 = getnumbval(self.Params.hgtoffset.value,0)
		bezelangle   = getnumbval(self.Params.bezelangle.value,0)
		steppedstyle = getboolval(self.Params.stepstyleset.value)
		flipsides	 = getboolval(self.Params.flipsides.value)
		withgaskets  = getboolval(self.Params.gasket.value)
	
		paneldef = {'panelshape' : 'Flat',
		'paneltype'	: 'Panel Style',
		'panelstyle'   : str(stylename),
		'steppedstyle' : str(bool(steppedstyle)),
		'edgeoffset'   : str(edgeoffset),
		'hgtoffset'	   : str(hgtoffset),
		'bezelangle'   : str(bezelangle),
		'flipsides'	   : str(bool(flipsides)),
		'withgaskets'  : str(bool(withgaskets)),
		'gasketthick'  : gasketthick,
		'gasketextend' : gasketextend,
		'gasketclass'  : gasketclass
		}
	
		if gasket:
			paneldef.update(gasketdef)
	
		result = {'PNP' : paneldef}
	
		#outputs
		self.Params.paneldef.value = result