	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Panels/Definition/Styled Panel Definition UI.py;
	# Created by Bill Wood 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "Styled Panel Definition UI" )
		this.SetDescription( 'Set styled panel definition' )
	
		#Input Ports
		edgeoffset = Marionette.OIPControl( 'Edge Offset', Marionette.WidgetType.Real, 0.0)
		edgeoffset.SetDescription('Panel edge offset')
	
		#OIP Input Controls
		hgtoffset = Marionette.OIPControl( 'Height Offset', Marionette.WidgetType.Real, 0.0)
		hgtoffset.SetDescription('Panel height offset')
	
		bezelangle = Marionette.OIPControl( 'Bezel Angle', Marionette.WidgetType.RealAngle, 0.0)
		bezelangle.SetDescription('Panel bezel angle (maximum 85deg) not applicable to Cushion')
	
		styletype = Marionette.OIPControl('Panel Style', Marionette.WidgetType.Popup, 0, ['Panel Single Glazed','Panel Double Glazed','Panel Triple Glazed','Panel Solid Skinned','Panel Style 1','Panel Style 2','Panel Style 3','Panel Style 4','Panel Style 5','Panel Style 6','Panel Style 7','Panel Style 8','Panel Style 9','Panel Style 10'] )
		styletype.SetDescription( "List of valid section types" )
	
		stepstyleset = Marionette.OIPControl( 'Stepped Style', Marionette.WidgetType.Bool, False)
		stepstyleset.SetDescription( "Draw panel stepped rather than as a bezel slope for core location greater than 1" )
	
		gasket = Marionette.OIPControl( 'With gaskets', Marionette.WidgetType.Bool, False)
		gasket.SetDescription( "Set panel with gaskets" )
	
		gasketthick = Marionette.OIPControl( 'Gasket Thickness', Marionette.WidgetType.Real, 2.0) # minimum 2mm
		gasketthick.SetDescription('Panel gasket thickness (minimum 2mm)')
	
		gasketextend = Marionette.OIPControl( 'Gasket Extension', Marionette.WidgetType.Real, 0.0)
		gasketextend.SetDescription('Panel gasket extension (greater than zero)')
	
		gasketclass = Marionette.OIPControl('Gasket Class', Marionette.WidgetType.Popup, 0, ['Panel-Gasket-Glass','Panel-Gasket-Solid','Panel-Gasket-1','Panel-Gasket-2','Panel-Gasket-3','Panel-Gasket-4','Panel-Gasket-5'] )
		gasketclass.SetDescription( "List of valid gasket classes" )
	
		flipsides = Marionette.OIPControl( 'Flip sides', Marionette.WidgetType.Bool, False)
		flipsides.SetDescription( "Draw panel on opposite side of shape" )
	
	
		#Output Ports
		paneldef = Marionette.PortOut('PanelDef')
		paneldef.SetDescription( "The resultant panel definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		#inputs
	
		paneldef = {'panelshape' : 'Flat',
		'paneltype'  : 'Panel Style',
		'panelstyle' : str(self.Params.styletype.value),
		'steppedstyle' : str(bool(self.Params.stepstyleset.value)),
		'edgeoffset' : str(self.Params.edgeoffset.value),
		'hgtoffset'  : str(self.Params.hgtoffset.value),
		'bezelangle' : str(self.Params.bezelangle.value),
		'flipsides'  : str(bool(self.Params.flipsides.value)),
		'withgaskets' : str(bool(self.Params.gasket.value)),
		'gasketthick' :str(self.Params.gasketthick.value),
		'gasketextend':str(self.Params.gasketextend.value),
		'gasketclass' :str(self.Params.gasketclass.value)
		}
	
		result = {'PNP' : paneldef}
	
		#outputs
		self.Params.panels.value = result