	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Panels/Gaskets/Panel Gaskets UI.py;
	# Created by Bill Wood 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	#APPEARANCE
		#Name
		this = Marionette.Node( "Panel Gaskets UI" )
		this.SetDescription( 'Set panel gasket definition' )
	
		#OIP Input Controls
		classname = Marionette.OIPControl('Gasket Class', Marionette.WidgetType.Popup, 0, ['Panel-Gasket-Glass','Panel-Gasket-Solid','Panel-Gasket-1','Panel-Gasket-2','Panel-Gasket-3','Panel-Gasket-4','Panel-Gasket-5'] )
		classname.SetDescription( "List of gasket classes" )
	
		thickness = Marionette.OIPControl( 'Gasket Thickness', Marionette.WidgetType.RealCoord, 2.0) # minimum 2mm
		thickness.SetDescription('Gasket thickness')
	
		extension = Marionette.OIPControl( 'Gasket Extend', Marionette.WidgetType.RealCoord, 0.0)
		extension.SetDescription('Gasket extension')
	
		#Output Ports
		poly = Marionette.PortOut('Gasketdef')
		poly.SetDescription( "The resultant gasket definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		gasketclass	 = self.Params.classname.value
		gasketthick  = self.Params.thickness.value # minimum thickness 2mm handled by panel pio
		gasketextend = self.Params.extension.value
	
		#outputs
		optionstring = {'PNG':{'gasketthick':str(gasketthick),'gasketextend':str(gasketextend),'gasketclass':gasketclass}}
		self.Params.poly.value = optionstring