	@Marionette.NodeDefinition
	#COMMAND;REFFILE;[UsrLib]/Defaults/Marionette/WW Tools/Panels/Gaskets/Panel Gaskets.py;
	# Created by Bill Wood 25/4/20
	
	class Params(metaclass = Marionette.OrderedClass):
	
		def getnumbvalue(value,defvalue):
			if isinstance(value,(list,tuple)):
				value = value[0]
			if isinstance(value,(int,float)):
				return value
			else:
				return defvalue
	
	#APPEARANCE
		#Name
		this = Marionette.Node( "Panel Gaskets" )
		this.SetDescription( 'Set panel gasket definition' )
	
		#Input Ports
		classname = Marionette.PortIn(0, 'sClass')
		classname.SetDescription( "Gasket class name" )
	
		thickness = Marionette.PortIn(0, 'nThickness')
		thickness.SetDescription( "Gasket thickness" )
		
		extension = Marionette.PortIn(0, 'nExtension')
		extension.SetDescription( "Gasket extension" )
	
		#Output Ports
		gasketdef = Marionette.PortOut('Gasketdef')
		gasketdef.SetDescription( "The resultant gasket definition" )
	
	#BEHAVIOR
	
	def RunNode(self):
		gasketclass	 = self.Params.classname.value
		if not gasketclass:
			gasketclass = 'Panel-Gasket-Glass'
	
		gasketthick  = self.Params.getnumbvalue(self.Params.thickness.value,0) # minimum thickness 2mm handled by panel pio
		gasketextend = self.Params.getnumbvalue(self.Params.extension.value,0)
	
		#outputs
		optionstring = {'PNG':{'gasketthick':str(gasketthick),'gasketextend':str(gasketextend),'gasketclass':gasketclass}}
		self.Params.gasketdef.value = optionstring