# Edited 220525 omitted examples and document content
# Edited 231027 pathconvert space before bracket removed.
# Edited 231031 removed all references to pathconvert as backslash works on Mac

import os
import vs
import shutil

# Set a name for a better folder organization -- don't forget the / at the end of the name
sPlugin = "Extrude tools/"
sMarionette = "Marionette/"
sWWTools = "Marionette/WWTools/"

def install ():
	# Use negative number to get user path and positive number to get application path
	sRenoPluginPath = vs.GetFolderPath(-2) + sPlugin

	sWorkspacePath = vs.GetFolderPath(-4)

	# Libraries/Defaults
	sUserEPPath = vs.GetFolderPath(-14) + sPlugin
	sMarionetteEPPath = vs.GetFolderPath(-14) + sMarionette
	sWWToolsPath = vs.GetFolderPath(-14) + sWWTools	
	
	bResult = vs.CreateFolder(sWorkspacePath)
	bResult = vs.CreateFolder(sUserEPPath)
	bResult = vs.CreateFolder(sMarionetteEPPath)

	major, minor, maintenance, platform = vs.GetVersion()
	VWversion = str(major + 1995)
	maribasename = 'Marionette EP Tools 2020.vwx'
	marireqname  = 'Marionette EP Tools ' + VWversion + '.vwx'
	mariset = False

	iCnt = 1
	while True: # loop the files
		sFilePath = vs.GetFilesInFolder(sRenoPluginPath, iCnt)
	
		if sFilePath == '': # no more files
			break
	
		sFileName, sExt = os.path.splitext(sFilePath) # actual filename
		sPath, sName = os.path.split(sFilePath)

		srcfname = sRenoPluginPath + sName # modified file path
	
		if sExt.lower() == '.vww':
			fname = sWorkspacePath + sName
			if os.path.exists(fname): os.remove(fname)
			os.rename(srcfname, fname)

		elif sExt.lower() == '.vwx':
			if sFileName.startswith('Marionette EP Tools'):
				fname = sMarionetteEPPath + sName # modified file path
				
				mariset = (sName == marireqname)
				if mariset: # found
					if os.path.exists(fname): os.remove(fname)
					os.rename(srcfname, fname)
				else:
					if sName == maribasename:
						marifname = sName
						marisrcfname = srcfname # keep base marionette 2020 file for later processing
						iCnt += 1
					else:
						os.remove(srcfname)
						marifname = ''

			else: iCnt += 1

		elif sFileName == 'WW Tools':
			fname = sMarionetteEPPath + sName # modified file path
			if os.path.exists(fname):
				shutil.rmtree(fname)
			os.rename(srcfname, fname)
		else: 
			iCnt += 1

	if mariset:
		os.remove(marisrcfname) # delete base marionette file 2020 as correct version processed
	else:
		#leave base marionette file 2020 for conversion to current VW version by user
		if marifname:
			fname = sMarionetteEPPath + marifname # modified file path
			if os.path.exists(fname): os.remove(fname)
			os.rename(marisrcfname, fname)

install ()